#!C:\Perl\bin\perl
use warnings;

##########################################################################################
## Author: Venice Margarette B. Juanillas 
## Date Created: May 27,2011
## Script Description: This script is intended to transform a matrix into its structure 
##						data file format. 
## Disclaimer: This script is not yet complete. This script cannot still fully be used 
##						for Structure transformation.
##########################################################################################



my $string;
my $temp_file; ## temporary file that will store the matrix before we append 
			## to the output file
my @array;			


## check for file parameters
if(!@ARGV or scalar(@ARGV) != 2){
	print "No Parameters specified...Specify 1.) matrix input data 2.) output file\n";
}else{                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
	$temp_file = "line.txt";
	transpose_data($ARGV[0],$temp_file); 
	change_symbol($temp_file,$ARGV[1]);
}

## transposes matrix data
## Marker names will become the new rows
## SNP_id will become the columns
sub transpose_data{
	my ($infile, $outfile) = @_;
	my $line;
	my $line_count = 1; ## start from the header
	my $next_line = 0; ## flag jump to next line
	my @row ;
	my @markers;
	
	
	## open files
	open(IN, "$infile")|| die "Cannot open $infile";
	open(OUT, ">$outfile")|| die "Cannot open $outfile ";
	
	## read file per line
	while($line = <IN>){
		next if $line =~ /^\s*$/; # skip blank lines
		if($line_count == 1){
			@markers = split(/\t/,$line); ## split the header, which contains the sample names and store them to an array
			$next_line =1;	## flag to got to the next line
			$line_count++;
			next;
		}
		if($next_line == 1){ ## go to the next line
			@row = split(/\t/,$line); ## split line
			for($i = 0; $i < $#row; $i++){
				
				$markers[$i] = $markers[$i]."\t".$row[$i]; ## append all alleles to their respective sample names/markers
			}
		
		}
	}
	
	for($i = 0;$i < $#markers;$i++){	## output to file all contents of the array
		print OUT $markers[$i]."\n"; 	## basically all that's in the matrix
	}
	
	## close files
	close(IN);
	close(OUT);
}

sub change_symbol{
	my ($file1,$file2) = @_;
	my $line;
	my $linecount = 1;
	my $new;
	my @row;
	my @alleles;
	my @header;
	
	open(IN,"$file1") || die "Cannot opne $file1";
	open(OUT,">$file2") || die "Cannot opne $file2";
	
	
	while($line = <IN>){
		next if $line =~ /^\s*$/; # skip blank lines 
		if ($linecount == 1){
			#@header = split(/\t|\s|\n/,$line);
			print OUT $line;
			$linecount++;
			next;
		}else{
			@row = split(/\t|\n|\s/,$line);
			for($i = 0;$i < $#row;$i++){
				if($row[$i] eq "-/-"){
					$row[$i] = "N";
				}
				if($row[$i] eq "A/A"){
					$row[$i] = "A";
				}
				if($row[$i] eq "C/C"){
					$row[$i] = "C";
				}
				if($row[$i] eq "A/B" || $row[$i] eq "B/B"){
					$row[$i] = "B";
				}
				if($row[$i] eq "C/G" || $row[$i] eq "G/G"){
					$row[$i] = "G";
				}
				if($row[$i] eq "A/T"||$row[$i] eq "T/T"){
					$row[$i] = "AT";
				}
				if($row[$i] eq "T/C"){
					$row[$i] = "TC";
				}
				if($row[$i] eq "B/C"){
					$row[$i] = "BC";
				}
				if($row[$i] eq "A/G"){
					$row[$i] = "AG";
				}
				
				#push(@alleles,$row[$i]);
			}
			$myline = join("\t",@row);
		}
		print OUT $myline."\n";
	}
	
	
	close(IN);
	close(OUT);
}


## 1.) This still needs further familiarization of the haploid, diploid, n-row formats
## 2.) How are alleles distributed per loci?
	
	
